/*
	File:		OSLToken.h

	Contains:	Routines to abstract the manipulation of tokens in the OSL

	Owned by:	Nick Pilch

	Copyright:	 1993 - 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <7>	 5/25/95	jpa		Use #pragma import [1241078]
		 <6>	  5/3/95	NP		1211084: Remove 5$
		 <5>	  2/8/95	NP		1218550: Don't allocate OSLContexts
									dynamically.
		 <4>	11/15/94	NP		1196322-made functions non-pascal, added a
									function.
		 <3>	 9/29/94	RA		1189812: Mods for 68K build.
		 <2>	 8/19/94	NP		1181622: Ownership fix.
		 <6>	  5/2/94	eeh		bug #1160654: wrap 'extern "C" {' around
									prototypes
		 <5>	  2/9/94	NP		Tiger Team cleanup.
		 <4>	 9/24/93	JA		Minor syntactic tweaks for THINK C++.
		 <3>	 8/19/93	NP		Changed const error code to a #define.
		 <2>	 8/16/93	NP		Adjusted for latest OSL proposal.
		 <1>	 8/11/93	NP		first checked in

	To Do:
*/

#ifndef _OSLTOKEN_
#define _OSLTOKEN_

#ifndef _CNTXTOSL_
#include "CntxtOSL.h"
#endif

#define errNotAValidToken -1730;

#ifdef _PLATFORM_MACINTOSH_
#pragma import on
#endif

#ifdef __cplusplus
extern "C" {
#endif

DescType OSLGetTokenDescType(const OSLToken* token);
void OSLSetTokenDescType(OSLToken* token, DescType appDescType);
Handle OSLGetTokenDataHandle(const OSLToken* token);
void OSLSetTokenDataHandle(OSLToken* token, Handle appHandle);
OSErr OSLGetTokenContext(const OSLToken* token, OSLContext* context);
OSErr OSLSetTokenContext(OSLToken* token, OSLContext* context);
//void StuffContextIntoToken(OSLToken* token, OSLContext context);
//OSLContext GetContextFromToken(OSLToken* token);

GetCallbackCallerProc OSLGetContextProc(const OSLContext* context);
long OSLGetContextRefCon(const OSLContext* context);
void OSLSetContextProc(OSLContext* context,
								GetCallbackCallerProc proc);
void OSLSetContextRefCon(OSLContext* context, long refCon);

#ifdef __cplusplus
}
#endif

#ifdef _PLATFORM_MACINTOSH_
#pragma import off
#endif

#endif /* _OSLTOKEN_ */
