/*
	File:		TempSI.h

	Contains:	Utility for exception-safe temporary reference to ODSemanticInterface

	Owned by:	Jens Alfke

	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <1>	 6/22/95	jpa		first checked in

	Theory Of Operation:
		See the utility TempObj.h.
*/

#ifndef _TEMPSI_
#define _TEMPSI_

#ifndef _TEMPOBJ_
#include <TempObj.h>
#endif

#ifndef SOM_ODSemanticInterface_xh
#include "SemtIntB.xh"
#endif


#ifdef _USE_TEMPLATES_

	typedef TempRef<ODSemanticInterface>	TempODSemanticInterface;

#else

	#ifdef __MWERKS__
		// Make sure 'pragma once' mode is off so the .th files can be included
		// more than once!
		#pragma push
		#pragma once off
	#endif

	#define _T_		ODSemanticInterface
	#define _C_		TempODSemanticInterface
	#include <TempRef.th>

	#ifdef __MWERKS__
		#pragma pop
	#endif

#endif

#endif /*_TEMPSI_*/
